"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class InteractionEventHandler {
    hook(client) {
        client.addListener('interactionCreate', this._handleInteraction);
    }
    use(handlers) {
        const h = Array.isArray(handlers) ? handlers : [handlers];
        h.forEach((h) => {
            this.managers.set(h._interactionCtor, h);
        });
    }
    _handleInteraction(interaction) {
        this.managers.forEach((v, k) => {
            // note to self: we can also use ctor.isPrototypeOf to check for inherited inheritance (but not selfreference)
            if (Object.getPrototypeOf(interaction).constructor === k) {
                v.onInteraction(interaction);
            }
        });
    }
}
exports.default = InteractionEventHandler;
