import { Interaction } from 'discord.js';
import BaseInteractionHandler from '../BaseInteractionHandler';
export default abstract class BaseInteractionManager<I extends Interaction = any, H extends BaseInteractionHandler = any, ID_TYPE = string> {
    _interactionCtor: {
        new (...args: any[]): I;
    };
    protected interactionHandlers: Map<ID_TYPE, H>;
    constructor(_interactionCtor: {
        new (...args: any[]): I;
    });
    registerInteractionHandler(id: ID_TYPE, handler: H): void;
    removeInteractionHandler(id: ID_TYPE): boolean;
    protected getInteractionHandler(interaction: I): H | undefined;
    protected abstract getInteractionId(interaction: I): ID_TYPE;
    protected abstract callInteraction(interaction: I): void;
    onInteraction(interaction: I): void;
}
