"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class BaseInteractionManager {
    constructor(_interactionCtor) {
        this._interactionCtor = _interactionCtor;
        this.interactionHandlers = new Map();
        this._interactionCtor = _interactionCtor;
    }
    registerInteractionHandler(id, handler) {
        this.interactionHandlers.set(id, handler);
    }
    removeInteractionHandler(id) {
        return this.interactionHandlers.delete(id);
    }
    getInteractionHandler(interaction) {
        return this.interactionHandlers.get(this.getInteractionId(interaction));
    }
    onInteraction(interaction) {
        this.callInteraction(interaction);
    }
}
exports.default = BaseInteractionManager;
